#include <stdio.h>
#include <sys/types.h>
#include <sys/msg.h>
#include <sys/ipc.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#define MSGKEY 75
struct msgform   //定义了一个消息结构体msgform，
{    
	long mtype;
	char mtext[1030];
}msg;
int msgqid,i;    //定义了消息队列标识符msgqid和一个整数变量i
void CLIENT()
{
	int i;
	msgqid=msgget(MSGKEY,0777);       //获得一个消息的描述符，该描述符指定一个消息队列以便用于其他系统调用。
	for (i=10;i>=1;i--)            //循环发送消息到消息队列。每个消息的类型从10递减到1，发送完成后退出进程。
	{ 
		msg.mtype=i;
		printf("(client) sent \n");
		msgsnd(msgqid,&msg,1024,0);
		
	}
	exit(0);
}
void SERVER()
{
	msgqid=msgget(MSGKEY,0777|IPC_CREAT);      //通过msgget()函数获取消息队列的标识符，然后循环接收消息，并打印接收到的消息内容。
	do{
		msgrcv(msgqid,&msg,1030,0,0);
		printf("(Server) recieved\n");
	} while(msg.mtype!=1);
	msgctl(msgqid,IPC_RMID,0);     //当服务器进程接收到特定类型的消息（msg.mtype==1）后，调用msgctl()函数使用IPC_RMID命令删除消息队列。
	exit(0);
}
void main()
{
	while((i=fork())==-1);
	if(!i) SERVER();
	while((i=fork())==-1);
	if(!i) CLIENT();
	wait(0);
	wait(0);
}
